<template>
  <div class="h-full w-full">
    <TableHeader>
      <div slot="left">
        <el-button size="small" type="primary" @click="handleAdd"
          >新增</el-button
        >
        <el-button size="small" type="danger" @click="handleDelAll"
          >批量删除</el-button
        >
      </div>
      <div slot="right">
        <el-form ref="searchForm" :model="searchForm" inline>
          <el-form-item prop="areaName">
            <el-input
              size="small"
              v-model="searchForm.areaName"
              style="width: 200px"
              class="ml10 mr10"
              placeholder="请输入区域名称搜索"
              @keyup.native.enter="handleSearch"
            ></el-input>
          </el-form-item>
          <el-form-item>
            <el-button size="small" type="primary" @click="handleSearch"
              >搜 索</el-button
            >
          </el-form-item>
          <el-form-item>
            <el-button size="small" @click="handleReset">重 置</el-button>
          </el-form-item>
        </el-form>
      </div>
    </TableHeader>
    <!-- 表格 -->
    <div class="table-content">
      <y-table
        ref="MyTable"
        :loading="loading"
        :data="tableData"
        :column="column"
        border
        tooltip-effect="dark"
        :max-height="600"
        :row-key="(row) => row.id"
        @selection-change="handleSelectionChange"
      ></y-table>
    </div>
    <Pagination
      :total="total"
      :current.sync="current"
      :size.sync="size"
      @get="getAccessList"
    ></Pagination>
    <!-- 新增 -->
    <AddAccess
      ref="AddAccess"
      :addVisible.sync="show"
      :title="title"
      @addSuccess="getAccessList"
    ></AddAccess>
  </div>
</template>

<script>
import TableHeader from "@/components/TableHeader.vue";
import AddAccess from "./components/AddAccess.vue";
import { getAccessList, delAccess } from "@/api/system";
export default {
  components: {
    TableHeader,
    AddAccess,
  },
  data() {
    return {
      column: [
        {
          label: "全选",
          type: "selection",
          width: "55",
          align: "center",
          reserveSelection: true,
        },
        {
          label: "序号",
          type: "index",
          width: "55",
          align: "center",
          index: (index) => {
            return (this.current - 1) * this.size + index + 1;
          },
        },

        {
          label: "区域名称",
          prop: "areaName",
          align: "center",
        },
        {
          label: "区域编码",
          prop: "areaCode",
          align: "center",
        },
        {
          label: "背景图片",
          prop: "bigPath",
          align: "center",
          formatter: (row) => {
            return (
              <el-image
                src={row.bigPath}
                previewSrcList={[row.bigPath]}
                class="w-[50px]"
              />
            );
          },
        },
        {
          label: "区域接入系统",
          align: "center",
          formatter: (row) => {
            if (row.tag) {
              return row.tag.split(",").map((v) => {
                return (
                  <el-tag type="info" class="mr-2">
                    {v}
                  </el-tag>
                );
              });
            }
          },
        },
        {
          label: "排序",
          prop: "sort",
          align: "center",
        },

        {
          label: "备注",
          prop: "remark",
          align: "center",
        },
        {
          label: "操作",
          align: "center",
          width: "120",
          formatter: (row) => {
            return (
              <div class="flex justify-center gap-4">
                <span
                  class="primary cursor-pointer"
                  onClick={() => this.handleEdit(row)}
                >
                  编辑
                </span>
                <span
                  class="delete cursor-pointer"
                  onClick={() => this.handleDel(row.id)}
                >
                  删除
                </span>
              </div>
            );
          },
        },
      ],
      searchForm: {
        areaName: "",
      },
      tableData: [],
      current: 1,
      size: 10,
      total: 0,
      loading: false,
      selectRows: [],
      show: false,
      title: "新增",
      dict: {}, // 字典
    };
  },
  created() {
    this.getAccessList();
  },
  computed: {},
  methods: {
    // 获取接入区域列表
    async getAccessList() {
      let res = await getAccessList({
        page: this.current,
        size: this.size,
        ...this.searchForm,
      });
      if (res.data.code == 1) {
        let { data, total, dict } = res.data.data;
        if (!data.length && this.current > 1) {
          this.current -= 1;
          this.getAccessList();
        }
        this.tableData = data;
        this.total = total;
        this.dict = dict;
      }
    },
    // 批量移除
    handleDelAll() {
      if (!this.selectRows.length) {
        this.$message.warning("请先勾选数据");
        return;
      }
      let ids = this.selectRows.map((v) => v.id).join(",");
      this.handleDel(ids);
    },
    // 搜索
    handleSearch() {
      this.current = 1;
      this.$clearSelection("MyTable");
      this.getAccessList();
    },
    // 重置
    handleReset() {
      this.current = 1;
      this.$clearSelection("MyTable");
      this.$resetForm("searchForm");
      this.getAccessList();
    },
    // 选中
    handleSelectionChange(select) {
      this.selectRows = select;
    },

    // 新增
    handleAdd() {
      this.title = "新增";
      this.$refs.AddAccess.onAdd();
      this.show = true;
    },
    // 编辑
    handleEdit(row) {
      this.title = "编辑";
      let data = this.$cloneDeep(row);
      this.$refs.AddAccess.onEdit(data);
      this.show = true;
    },
    // 移除
    handleDel(id) {
      this.$confirm("此操作将删除所选数据，是否继续？", "系统提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        cancelButtonClass: "btn-custom-cancel",
        type: "warning",
      })
        .then(async () => {
          let res = await delAccess({ id });
          let { code, msg } = res.data;
          if (code === 1) {
            this.$message.success(msg);
            this.getAccessList();
            this.$clearSelection("MyTable");
          }
        })
        .catch(() => {
          console.log("取消成功！");
        });
    },
  },
};
</script>

<style lang="less" scoped></style>
